]> git.saurik.com Git - apt.git/blame - test/integration/framework
elimate duplicated code in pkgIndexFile subclasses
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
5d76cee1 3EXIT_CODE=0
8c1dd12c 4
8d876415 5# we all like colorful messages
a09f6eb8 6if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
27cb4f6c 7 if [ ! -t 1 ]; then # but check that we output to a terminal
1290422a
DK
8 export MSGCOLOR='NO'
9 fi
10fi
11
12
13if [ "$MSGCOLOR" != 'NO' ]; then
14 CERROR="\033[1;31m" # red
15 CWARNING="\033[1;33m" # yellow
16 CMSG="\033[1;32m" # green
17 CINFO="\033[1;96m" # light blue
18 CDEBUG="\033[1;94m" # blue
19 CNORMAL="\033[0;39m" # default system console color
20 CDONE="\033[1;32m" # green
21 CPASS="\033[1;32m" # green
22 CFAIL="\033[1;31m" # red
23 CCMD="\033[1;35m" # pink
682a3bf7 24fi
8d876415 25
de81b2e2
DK
26msgprintf() {
27 local START="$1"
28 local MIDDLE="$2"
29 local END="$3"
30 shift 3
31 if [ -n "$1" ]; then
32 printf "$START " "$1"
d73840dc 33 shift
de81b2e2 34 while [ -n "$1" ]; do
03aa0847 35 printf "$MIDDLE " "$(echo "$1" | sed -e 's#^apt\([cfghs]\)#apt-\1#')"
de81b2e2
DK
36 shift
37 done
38 fi
39 printf "${END}"
2a2a7ef4 40}
de81b2e2
DK
41msgdie() { msgprintf "${CERROR}E: %s" '%s' "${CNORMAL}\n" "$@" >&2; exit 1; }
42msgwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}\n" "$@" >&2; }
43msgmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}\n" "$@"; }
44msginfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}\n" "$@"; }
45msgdebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}\n" "$@"; }
46msgdone() { msgprintf "${CDONE}DONE" '%s' "${CNORMAL}\n" "$@"; }
47msgnwarn() { msgprintf "${CWARNING}W: %s" '%s' "${CNORMAL}" "$@" >&2; }
48msgnmsg() { msgprintf "${CMSG}%s" '%s' "${CNORMAL}" "$@"; }
49msgninfo() { msgprintf "${CINFO}I: %s" '%s' "${CNORMAL}" "$@"; }
50msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
51msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
3c528b91 52msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
68ba0b7f
DK
53msgskip() {
54 if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
55 else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
56}
5229b285 57msgfail() {
3c528b91
MO
58 if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
59 else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
03aa0847
DK
60 if [ -n "$APT_DEBUG_TESTS" ]; then
61 $SHELL
62 fi
5229b285
DK
63 EXIT_CODE=$((EXIT_CODE+1));
64}
8d876415
DK
65
66# enable / disable Debugging
fc89263e
DK
67MSGLEVEL=${MSGLEVEL:-3}
68if [ $MSGLEVEL -le 0 ]; then
69 msgdie() { true; }
70fi
71if [ $MSGLEVEL -le 1 ]; then
72 msgwarn() { true; }
73 msgnwarn() { true; }
74fi
75if [ $MSGLEVEL -le 2 ]; then
76 msgmsg() { true; }
77 msgnmsg() { true; }
39cc8228 78 msgtest() { true; }
3c528b91 79 msgpass() { printf " ${CPASS}P${CNORMAL}"; }
fc89263e
DK
80fi
81if [ $MSGLEVEL -le 3 ]; then
82 msginfo() { true; }
83 msgninfo() { true; }
84fi
85if [ $MSGLEVEL -le 4 ]; then
86 msgdebug() { true; }
87 msgndebug() { true; }
88fi
89msgdone() {
90 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
91 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
92 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
93 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
94 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
95 true;
96 else
3c528b91 97 printf "${CDONE}DONE${CNORMAL}\n";
fc89263e
DK
98 fi
99}
e43a426e
MV
100getaptconfig() {
101 if [ -f ./aptconfig.conf ]; then
5465192b 102 echo "$(readlink -f ./aptconfig.conf)"
e43a426e 103 elif [ -f ../aptconfig.conf ]; then
5465192b
DK
104 echo "$(readlink -f ../aptconfig.conf)"
105 elif [ -f ../../aptconfig.conf ]; then
106 echo "$(readlink -f ../../aptconfig.conf)"
107 elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
108 echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
109 fi
e43a426e 110}
8d876415
DK
111runapt() {
112 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
846856f4
DK
113 local CMD="$1"
114 shift
3b8eb3bc 115 case $CMD in
a311fb96 116 sh|aptitude|*/*|command) ;;
3b8eb3bc
DK
117 *) CMD="${BUILDDIRECTORY}/$CMD";;
118 esac
a311fb96 119 MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${LIBRARYPATH} $CMD "$@"
8d876415 120}
846856f4
DK
121aptconfig() { runapt apt-config "$@"; }
122aptcache() { runapt apt-cache "$@"; }
123aptcdrom() { runapt apt-cdrom "$@"; }
124aptget() { runapt apt-get "$@"; }
125aptftparchive() { runapt apt-ftparchive "$@"; }
126aptkey() { runapt apt-key "$@"; }
127aptmark() { runapt apt-mark "$@"; }
4f6d26b4 128aptsortpkgs() { runapt apt-sortpkgs "$@"; }
796673c3 129apt() { runapt apt "$@"; }
3b8eb3bc
DK
130apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; }
131aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; }
132aptitude() { runapt aptitude "$@"; }
8d50b63f 133aptextracttemplates() { runapt apt-extracttemplates "$@"; }
3082603f 134aptinternalsolver() { runapt "${APTINTERNALSOLVER}" "$@"; }
ad7e0941 135aptdumpsolver() { runapt "${APTDUMPSOLVER}" "$@"; }
3b8eb3bc 136
158fda31 137dpkg() {
b0be0e09 138 "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg" "$@"
158fda31 139}
ce7f128c
DK
140dpkgcheckbuilddeps() {
141 command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@"
b6b5a542 142}
3fa950f1 143gdb() {
b07aeb1a
DK
144 local CMD
145 case "$1" in
146 aptget) CMD="apt-get";;
147 aptcache) CMD="apt-cache";;
5465192b
DK
148 aptcdrom) CMD="apt-cdrom";;
149 aptconfig) CMD="apt-config";;
b07aeb1a
DK
150 aptmark) CMD="apt-mark";;
151 apthelper) CMD="apt-helper";;
3d8232bf 152 aptftparchive) CMD="apt-ftparchive";;
b07aeb1a
DK
153 *) CMD="$1";;
154 esac
ce928105 155 shift
a311fb96 156 runapt command gdb --quiet -ex run "${BUILDDIRECTORY}/$CMD" --args "${BUILDDIRECTORY}/$CMD" "$@"
ae99ce2e 157}
8d876415 158
8c1dd12c 159exitwithstatus() {
f91bd741
MV
160 # error if we about to overflow, but ...
161 # "255 failures ought to be enough for everybody"
5d76cee1
MV
162 if [ $EXIT_CODE -gt 255 ]; then
163 msgdie "Total failure count $EXIT_CODE too big"
f91bd741 164 fi
5d76cee1 165 exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255));
8c1dd12c
MV
166}
167
804d4a0d
DK
168shellsetedetector() {
169 local exit_status=$?
170 if [ "$exit_status" != '0' ]; then
3c528b91 171 printf >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}\n"
804d4a0d
DK
172 if [ "$EXIT_CODE" = '0' ]; then
173 EXIT_CODE="$exit_status"
174 fi
175 fi
176}
177
b720d0bd 178addtrap() {
8437b7d4
DK
179 if [ "$1" = 'prefix' ]; then
180 CURRENTTRAP="$2 $CURRENTTRAP"
181 else
182 CURRENTTRAP="$CURRENTTRAP $1"
183 fi
804d4a0d 184 trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 185}
8d876415
DK
186
187setupenvironment() {
0d303f17
DK
188 # privilege dropping and testing doesn't work if /tmp isn't world-writeable (as e.g. with libpam-tmpdir)
189 if [ -n "$TMPDIR" ] && [ "$(id -u)" = '0' ] && [ "$(stat --format '%a' "$TMPDIR")" != '1777' ]; then
190 unset TMPDIR
191 fi
75954ae2 192 TMPWORKINGDIRECTORY=$(mktemp -d)
5684f71f 193 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
3cbbda3c 194 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
5c0dd6fc 195
03aa0847 196 mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
197 if [ "$(id -u)" = '0' ]; then
198 # relax permissions so that running as root with user switching works
199 umask 022
03aa0847
DK
200 chmod 711 "$TMPWORKINGDIRECTORY"
201 chown _apt:root "${TMPWORKINGDIRECTORY}/downloaded"
68ba0b7f
DK
202 fi
203
5684f71f 204 TESTDIRECTORY=$(readlink -f $(dirname $0))
5c0dd6fc 205 # allow overriding the default BUILDDIR location
e8fb1cdf 206 SOURCEDIRECTORY=${APT_INTEGRATION_TESTS_SOURCE_DIR:-"${TESTDIRECTORY}/../../"}
5c0dd6fc 207 BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"}
3b8eb3bc 208 LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"}
5c0dd6fc 209 METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"}
e43a426e 210 APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"}
c035b655 211 APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"}
3082603f 212 APTINTERNALSOLVER=${APT_INTEGRATION_TESTS_INTERNAL_SOLVER:-"${BUILDDIRECTORY}/apt-internal-solver"}
ad7e0941 213 APTDUMPSOLVER=${APT_INTEGRATION_TESTS_DUMP_SOLVER:-"${BUILDDIRECTORY}/apt-dump-solver"}
8d876415 214 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
5c0dd6fc
MV
215 # -----
216
8d876415 217 cd $TMPWORKINGDIRECTORY
cd725954 218 mkdir rootdir aptarchive keys
8d876415 219 cd rootdir
b29c3712 220 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
8fe964f1 221 mkdir -p usr/bin var/cache var/lib var/log tmp
cffea9af 222 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 223 touch var/lib/dpkg/available
8d876415 224 mkdir -p usr/lib/apt
9082a1fc 225 ln -s ${METHODSDIR} usr/lib/apt/methods
1f6cf9e7
DK
226 if [ "$BUILDDIRECTORY" = "$LIBRARYPATH" ]; then
227 mkdir -p usr/lib/apt/solvers
228 ln -s "${BUILDDIRECTORY}/apt-dump-solver" usr/lib/apt/solvers/dump
229 ln -s "${BUILDDIRECTORY}/apt-internal-solver" usr/lib/apt/solvers/apt
230 echo "Dir::Bin::Solvers \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/solvers\";" > etc/apt/apt.conf.d/externalsolver.conf
231 fi
291a386f
MV
232 # use the autoremove from the BUILDDIRECTORY if its there, otherwise
233 # system
234 if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then
235 ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove
236 else
237 ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove
238 fi
8d876415 239 cd ..
2c6baa5a 240 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
241 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
242 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 243 fi
4a4ea26c 244 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
245 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
246 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 247 fi
53ea1b56 248 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
5684f71f 249 chmod 644 $(find keys -name '*.pub' -o -name '*.sec')
cd725954 250 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
d6cf2345 251
cffea9af 252 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 253 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415 254 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
9d2a8a73 255 echo "Dir::Bin::Methods \"${TMPWORKINGDIRECTORY}/rootdir/usr/lib/apt/methods\";" >> aptconfig.conf
68ba0b7f
DK
256 # store apt-key were we can access it, even if we run it as a different user
257 # destroys coverage reporting though, so just do it for root for now
258 if [ "$(id -u)" = '0' ]; then
259 cp "${BUILDDIRECTORY}/apt-key" "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/"
260 chmod o+rx "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key"
261 echo "Dir::Bin::apt-key \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/apt-key\";" >> aptconfig.conf
262 else
263 echo "Dir::Bin::apt-key \"${BUILDDIRECTORY}/apt-key\";" >> aptconfig.conf
264 fi
b0be0e09 265
d61960d9 266 cat << EOF > "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
b0be0e09
DK
267#!/bin/sh
268set -e
269if [ -r "${TMPWORKINGDIRECTORY}/noopchroot.so" ]; then
270 if [ -n "\$LD_PRELOAD" ]; then
271 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so \${LD_PRELOAD}"
272 else
273 export LD_PRELOAD="${TMPWORKINGDIRECTORY}/noopchroot.so"
274 fi
275fi
276exec fakeroot dpkg --root="${TMPWORKINGDIRECTORY}/rootdir" \\
277 --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log \\
278 --force-not-root --force-bad-path "\$@"
279EOF
b0be0e09
DK
280 chmod +x "${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg"
281 echo "Dir::Bin::dpkg \"${TMPWORKINGDIRECTORY}/rootdir/usr/bin/dpkg\";" > rootdir/etc/apt/apt.conf.d/99dpkg
282
533fe3d1
DK
283 {
284 if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then
285 echo "DPKG::options:: \"--force-architecture\";" # Added to test multiarch before dpkg is ready for it…
286 fi
287 echo 'quiet::NoUpdate "true";'
288 echo 'quiet::NoStatistic "true";'
289 # too distracting for users, but helpful to detect changes
290 echo 'Acquire::Progress::Ignore::ShowErrorText "true";'
291 echo 'Acquire::Progress::Diffpercent "true";'
292 # in testcases, it can appear as if localhost has a rotation setup,
293 # hide this as we can't really deal with it properly
294 echo 'Acquire::Failure::ShowIP "false";'
295 } >> aptconfig.conf
d6cf2345 296
68ba0b7f
DK
297 cp "${TESTDIRECTORY}/apt.pem" "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
298 if [ "$(id -u)" = '0' ]; then
299 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem"
300 fi
301 echo "Acquire::https::CaInfo \"${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem\";" > rootdir/etc/apt/apt.conf.d/99https
d6cf2345 302 echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary
276e51dd 303 configcompression '.' 'gz' #'bz2' 'lzma' 'xz'
77a45beb 304
4bb006d1
DK
305 # create some files in /tmp and look at user/group to get what this means
306 TEST_DEFAULT_USER="$USER"
307 if [ "$(uname)" = 'GNU/kFreeBSD' ]; then
308 TEST_DEFAULT_GROUP='root'
309 else
310 TEST_DEFAULT_GROUP="$USER"
311 fi
312
d4f4bcf7
MV
313 # Acquire::AllowInsecureRepositories=false is not yet the default
314 # but we want it to be the default soon
315 configallowinsecurerepositories "false";
316
ce7f128c 317 # cleanup the environment a bit
8c617819
MV
318 # prefer our apt binaries over the system apt binaries
319 export PATH="${BUILDDIRECTORY}:${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
be233796 320 export LC_ALL=C.UTF-8
3b8eb3bc 321 unset LANGUAGE APT_CONFIG
ce7f128c
DK
322 unset GREP_OPTIONS DEB_BUILD_PROFILES
323
8d876415
DK
324 msgdone "info"
325}
326
ea65d079
DK
327getarchitecture() {
328 if [ "$1" = "native" -o -z "$1" ]; then
329 eval `aptconfig shell ARCH APT::Architecture`
330 if [ -n "$ARCH" ]; then
331 echo $ARCH
332 else
5834d7a1 333 dpkg --print-architecture
ea65d079
DK
334 fi
335 else
336 echo $1
337 fi
338}
339
53ea1b56 340getarchitectures() {
081c9d44 341 aptconfig dump --no-empty --format '%v%n' APT::Architecture APT::Architectures | sort -u | tr '\n' ' '
53ea1b56
DK
342}
343
3dcdc1f9
DK
344getarchitecturesfromcommalist() {
345 echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/"
346}
347
8d876415 348configarchitecture() {
18908589
DK
349 {
350 echo "APT::Architecture \"$(getarchitecture $1)\";"
351 while [ -n "$1" ]; do
352 echo "APT::Architectures:: \"$(getarchitecture $1)\";"
353 shift
354 done
355 } >rootdir/etc/apt/apt.conf.d/01multiarch.conf
53ea1b56
DK
356 configdpkg
357}
358
359configdpkg() {
360 if [ ! -e rootdir/var/lib/dpkg/status ]; then
361 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
362 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
363 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
364 else
365 echo -n > rootdir/var/lib/dpkg/status
366 fi
367 fi
18908589 368 rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg
846856f4 369 if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then
53ea1b56
DK
370 local ARCHS="$(getarchitectures)"
371 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
372 DPKGARCH="$(dpkg --print-architecture)"
373 for ARCH in ${ARCHS}; do
feae193b 374 if [ "${ARCH}" != "${DPKGARCH}" ]; then
18908589 375 if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then
feae193b 376 # old-style used e.g. in Ubuntu-P – and as it seems travis
18908589
DK
377 echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
378 echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg
feae193b
DK
379 fi
380 fi
53ea1b56
DK
381 done
382 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
383 # dpkg doesn't really check the version as long as it is fully installed,
384 # but just to be sure we choose one above the required version
385 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
386 fi
387 fi
388 fi
8d876415
DK
389}
390
0c787570
DK
391configdpkgnoopchroot() {
392 # create a library to noop chroot() and rewrite maintainer script executions
393 # via execvp() as used by dpkg as we don't want our rootdir to be a fullblown
394 # chroot directory dpkg could chroot into to execute the maintainer scripts
395 msgtest 'Building library to preload to make maintainerscript work in' 'dpkg'
396 cat << EOF > noopchroot.c
397#define _GNU_SOURCE
398#include <stdio.h>
399#include <stdlib.h>
400#include <string.h>
401#include <dlfcn.h>
402
403static char * chrootdir = NULL;
404
405int chroot(const char *path) {
406 printf("WARNING: CHROOTing to %s was ignored!\n", path);
407 free(chrootdir);
408 chrootdir = strdup(path);
409 return 0;
410}
411int execvp(const char *file, char *const argv[]) {
412 static int (*func_execvp) (const char *, char * const []) = NULL;
413 if (func_execvp == NULL)
414 func_execvp = (int (*) (const char *, char * const [])) dlsym(RTLD_NEXT, "execvp");
415 if (chrootdir == NULL || strncmp(file, "/var/lib/dpkg/", strlen("/var/lib/dpkg/")) != 0)
416 return func_execvp(file, argv);
417 printf("REWRITE execvp call %s into %s\n", file, chrootdir);
418 char newfile[strlen(chrootdir) + strlen(file)];
419 strcpy(newfile, chrootdir);
420 strcat(newfile, file);
b0be0e09
DK
421 char const * const baseadmindir = "/var/lib/dpkg";
422 char admindir[strlen(chrootdir) + strlen(baseadmindir)];
423 strcpy(admindir, chrootdir);
424 strcat(admindir, baseadmindir);
425 setenv("DPKG_ADMINDIR", admindir, 1);
0c787570
DK
426 return func_execvp(newfile, argv);
427}
428EOF
429 testsuccess --nomsg gcc -fPIC -shared -o noopchroot.so noopchroot.c -ldl
0c787570
DK
430}
431
d4f4bcf7
MV
432configallowinsecurerepositories() {
433 echo "Acquire::AllowInsecureRepositories \"$1\";" > rootdir/etc/apt/apt.conf.d/allow-insecure-repositories.conf
434
435}
436
276e51dd
DK
437configcompression() {
438 while [ -n "$1" ]; do
439 case "$1" in
3c528b91
MO
440 '.') printf ".\t.\tcat\n";;
441 'gz') printf "gzip\tgz\tgzip\n";;
442 'bz2') printf "bzip2\tbz2\tbzip2\n";;
443 'lzma') printf "lzma\tlzma\txz --format=lzma\n";;
444 'xz') printf "xz\txz\txz\n";;
445 *) printf "$1\t$1\t$1\n";;
276e51dd
DK
446 esac
447 shift
448 done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf
449}
450
5f982b9d
DK
451forcecompressor() {
452 COMPRESSOR="$1"
453 COMPRESSOR_CMD="$1"
454 case $COMPRESSOR in
455 gzip) COMPRESS='gz';;
456 bzip2) COMPRESS='bz2';;
457 lzma) COMPRESS='lzma';;
458 xz) COMPRESS='xz';;
459 *) msgdie "Compressor $COMPRESSOR is unknown to framework, so can't be forced by forcecompressor!";;
460 esac
461 local CONFFILE="${TMPWORKINGDIRECTORY}/rootdir/etc/apt/apt.conf.d/00force-compressor"
462 echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
463Dir::Bin::uncompressed \"/does/not/exist\";
464Dir::Bin::gzip \"/does/not/exist\";
465Dir::Bin::bzip2 \"/does/not/exist\";
466Dir::Bin::lzma \"/does/not/exist\";
467Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
468 if [ -e "/bin/${COMPRESSOR}" ]; then
469 echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> "$CONFFILE"
470 elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
471 echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> "$CONFFILE"
472 elif [ "${COMPRESSOR}" = 'lzma' ]; then
473 echo 'Dir::Bin::xz "/usr/bin/xz";' >> "$CONFFILE"
474 COMPRESSOR_CMD='xz --format=lzma'
475 else
476 msgtest 'Test for availability of compressor' "${COMPRESSOR}"
477 msgfail
478 fi
479}
480
75954ae2 481setupsimplenativepackage() {
ce9864a8
DK
482 local NAME="$1"
483 local ARCH="$2"
484 local VERSION="$3"
485 local RELEASE="${4:-unstable}"
486 local DEPENDENCIES="$5"
14109555 487 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
488 If you find such a package installed on your system,
489 something went horribly wrong! They are autogenerated
490 und used only by testcases and surf no other propose…"}"
491
b7899b00
DK
492 local SECTION="${7:-others}"
493 local DISTSECTION
494 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
495 DISTSECTION="main"
496 else
497 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
498 fi
ce9864a8
DK
499 local BUILDDIR=incoming/${NAME}-${VERSION}
500 mkdir -p ${BUILDDIR}/debian/source
501 cd ${BUILDDIR}
502 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
503 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
504 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
505
506 * Initial release
507
b7899b00
DK
508 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
509 test -e debian/control || echo "Source: $NAME
510Section: $SECTION
ce9864a8
DK
511Priority: optional
512Maintainer: Joe Sixpack <joe@example.org>
513Build-Depends: debhelper (>= 7)
514Standards-Version: 3.9.1
515
875bcb36
DK
516Package: $NAME" > debian/control
517 if [ "$ARCH" = 'all' ]; then
518 echo "Architecture: all" >> debian/control
519 else
520 echo "Architecture: any" >> debian/control
521 fi
ce9864a8 522 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
18908589
DK
523 echo "Description: $DESCRIPTION" >> debian/control
524
b7899b00
DK
525 test -e debian/compat || echo "7" > debian/compat
526 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 527 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
528 cd - > /dev/null
529}
530
531buildsimplenativepackage() {
532 local NAME="$1"
d56e2917
DK
533 local NM
534 if [ "$(echo "$NAME" | cut -c 1-3)" = 'lib' ]; then
535 NM="$(echo "$NAME" | cut -c 1-4)"
536 else
537 NM="$(echo "$NAME" | cut -c 1)"
538 fi
75954ae2
DK
539 local ARCH="$2"
540 local VERSION="$3"
541 local RELEASE="${4:-unstable}"
542 local DEPENDENCIES="$5"
14109555 543 local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
18908589
DK
544 If you find such a package installed on your system,
545 something went horribly wrong! They are autogenerated
546 und used only by testcases and surf no other propose…"}"
547
75954ae2 548 local SECTION="${7:-others}"
d67004e0 549 local PRIORITY="${8:-optional}"
42c1513b 550 local FILE_TREE="$9"
adff049d 551 local COMPRESS_TYPE="${10:-gzip}"
75954ae2
DK
552 local DISTSECTION
553 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
554 DISTSECTION="main"
555 else
556 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
557 fi
5a635ee4 558 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 559
0c787570 560 msgtest "Build source package in version ${VERSION} for ${RELEASE} in ${DISTSECTION}" "$NAME"
b761356f
DK
561 mkdir -p $BUILDDIR/debian/source
562 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
563 echo "#!/bin/sh
564echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
565
566 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
567 echo "$NAME ($VERSION) $RELEASE; urgency=low
568
569 * Initial release
570
571 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
572 echo "Source: $NAME
573Section: $SECTION
d67004e0 574Priority: $PRIORITY
b761356f 575Maintainer: Joe Sixpack <joe@example.org>
01f520ce
DK
576Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
577 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
578 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
579 echo "
580Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 581
875bcb36
DK
582 if [ "$ARCH" = 'all' ]; then
583 echo "Architecture: all" >> ${BUILDDIR}/debian/control
584 else
585 echo "Architecture: any" >> ${BUILDDIR}/debian/control
586 fi
01f520ce
DK
587 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
588 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
18908589 589 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
01f520ce 590
b761356f 591 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
0c787570
DK
592 cd ${BUILDDIR}/..
593 testsuccess --nomsg dpkg-source -b ${NAME}-${VERSION}
594 cd - >/dev/null
595 sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output \
f1828b69 596 | while read SRC; do
5a635ee4 597 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
f1828b69 598# if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then
33a22672 599# aptkey --keyring ./keys/joesixpack.pub --secret-keyring ./keys/joesixpack.sec --quiet --readonly \
bd7fb5aa 600# adv --yes --default-key 'Joe Sixpack' \
f1828b69
DK
601# --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
602# mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC"
603# fi
b761356f 604 done
84aa13f4 605
3dcdc1f9 606 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
0c787570 607 msgtest "Build binary package for ${RELEASE} in ${SECTION}" "$NAME"
84aa13f4
DK
608 rm -rf ${BUILDDIR}/debian/tmp
609 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
610 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
611 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
42c1513b
MV
612 if [ -n "$FILE_TREE" ]; then
613 cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp
614 fi
42c1513b 615
84aa13f4
DK
616 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
617 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
846856f4 618 local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log"
d56e2917 619 # ensure the right permissions as dpkg-deb insists
eb9dee96 620 chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN
0c787570 621 testsuccess --nomsg dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/..
84aa13f4
DK
622 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
623 done
624
d56e2917
DK
625 local CHANGEPATH="${BUILDDIR}/../${DISTSECTION}/${NM}/${NAME}/${NAME}_${VERSION}"
626 mkdir -p $CHANGEPATH
627 cp ${BUILDDIR}/debian/changelog $CHANGEPATH
5a635ee4 628 rm -rf "${BUILDDIR}"
b761356f 629 msgdone "info"
75954ae2
DK
630}
631
632buildpackage() {
633 local BUILDDIR=$1
634 local RELEASE=$2
635 local SECTION=$3
ea65d079 636 local ARCH=$(getarchitecture $4)
846856f4
DK
637 local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')"
638 local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")"
0c787570 639 msgtest "Build package for ${RELEASE} in ${SECTION}" "$PKGNAME"
75954ae2
DK
640 cd $BUILDDIR
641 if [ "$ARCH" = "all" ]; then
642 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
643 fi
0c787570
DK
644 testsuccess --nomsg dpkg-buildpackage -uc -us -a$ARCH
645 cp ${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output $BUILDLOG
846856f4
DK
646 local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")"
647 local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 648 cd - > /dev/null
b7899b00 649 for PKG in $PKGS; do
75954ae2 650 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
651 done
652 for SRC in $SRCS; do
75954ae2 653 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 654 done
ce9864a8
DK
655}
656
657buildaptarchive() {
ce9864a8 658 if [ -d incoming ]; then
846856f4 659 buildaptarchivefromincoming "$@"
ce9864a8 660 else
846856f4 661 buildaptarchivefromfiles "$@"
ce9864a8
DK
662 fi
663}
664
665createaptftparchiveconfig() {
276e51dd 666 local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')"
016bea82
DK
667 local COMPRESSORS="${COMPRESSORS%* }"
668 local ARCHS="$(getarchitectures)"
ce9864a8
DK
669 echo -n 'Dir {
670 ArchiveDir "' >> ftparchive.conf
671 echo -n $(readlink -f .) >> ftparchive.conf
672 echo -n '";
673 CacheDir "' >> ftparchive.conf
674 echo -n $(readlink -f ..) >> ftparchive.conf
675 echo -n '";
b7899b00
DK
676 FileListDir "' >> ftparchive.conf
677 echo -n $(readlink -f pool/) >> ftparchive.conf
678 echo -n '";
679};
680Default {
276e51dd
DK
681 Packages::Compress "'"$COMPRESSORS"'";
682 Sources::Compress "'"$COMPRESSORS"'";
683 Contents::Compress "'"$COMPRESSORS"'";
684 Translation::Compress "'"$COMPRESSORS"'";
18331adf 685 LongDescription "false";
ce9864a8
DK
686};
687TreeDefault {
688 Directory "pool/";
689 SrcDirectory "pool/";
690};
691APT {
692 FTPArchive {
693 Release {
694 Origin "joesixpack";
695 Label "apttestcases";
696 Suite "unstable";
697 Description "repository with dummy packages";
698 Architectures "' >> ftparchive.conf
699 echo -n "$ARCHS" >> ftparchive.conf
700 echo 'source";
701 };
702 };
703};' >> ftparchive.conf
b7899b00
DK
704 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
705 echo -n 'tree "dists/' >> ftparchive.conf
706 echo -n "$DIST" >> ftparchive.conf
707 echo -n '" {
ce9864a8
DK
708 Architectures "' >> ftparchive.conf
709 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
710 echo -n 'source";
711 FileList "' >> ftparchive.conf
712 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
713 echo -n '";
714 SourceFileList "' >> ftparchive.conf
715 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
716 echo -n '";
717 Sections "' >> ftparchive.conf
718 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
719 echo '";
ce9864a8 720};' >> ftparchive.conf
b7899b00 721 done
ce9864a8
DK
722}
723
724buildaptftparchivedirectorystructure() {
b7899b00
DK
725 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
726 for DIST in $DISTS; do
727 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
728 for SECTION in $SECTIONS; do
729 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
730 for ARCH in $ARCHS; do
731 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
732 done
733 mkdir -p dists/${DIST}/${SECTION}/source
734 mkdir -p dists/${DIST}/${SECTION}/i18n
735 done
ce9864a8 736 done
ce9864a8
DK
737}
738
9b78cda6 739insertpackage() {
10e100e5 740 local RELEASES="$1"
9b78cda6
DK
741 local NAME="$2"
742 local ARCH="$3"
743 local VERSION="$4"
744 local DEPENDENCIES="$5"
d67004e0 745 local PRIORITY="${6:-optional}"
10e100e5 746 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASES}
18908589
DK
747 If you find such a package installed on your system,
748 something went horribly wrong! They are autogenerated
749 und used only by testcases and surf no other propose…"}"
d67004e0 750 local ARCHS=""
10e100e5
DK
751 for RELEASE in $(printf '%s' "$RELEASES" | tr ',' '\n'); do
752 if [ "$RELEASE" = 'installed' ]; then
753 insertinstalledpackage "$2" "$3" "$4" "$5" "$6" "$7"
754 continue
d67004e0 755 fi
10e100e5
DK
756 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
757 if [ "$arch" = 'all' -o "$arch" = 'none' ]; then
758 ARCHS="$(getarchitectures)"
759 else
760 ARCHS="$arch"
761 fi
762 for BUILDARCH in $ARCHS; do
763 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
764 mkdir -p $PPATH
765 local FILE="${PPATH}/Packages"
766 echo "Package: $NAME
d67004e0 767Priority: $PRIORITY
9b78cda6 768Section: other
2c085486 769Installed-Size: 42
c919ad6e 770Maintainer: Joe Sixpack <joe@example.org>" >> $FILE
10e100e5
DK
771 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
772 echo "Version: $VERSION
d67004e0 773Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
10e100e5
DK
774 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
775 echo "Description: $(printf '%s' "$DESCRIPTION" | head -n 1)" >> $FILE
776 echo "Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)" >> $FILE
777 echo >> $FILE
778 done
d67004e0 779 done
10e100e5
DK
780 mkdir -p aptarchive/dists/${RELEASE}/main/source aptarchive/dists/${RELEASE}/main/i18n
781 touch aptarchive/dists/${RELEASE}/main/source/Sources
782 echo "Package: $NAME
0e0d9919
DK
783Description-md5: $(printf '%s' "$DESCRIPTION" | md5sum | cut -d' ' -f 1)
784Description-en: $DESCRIPTION
785" >> aptarchive/dists/${RELEASE}/main/i18n/Translation-en
10e100e5 786 done
9b78cda6
DK
787}
788
234675b7
DK
789insertsource() {
790 local RELEASE="$1"
791 local NAME="$2"
792 local ARCH="$3"
793 local VERSION="$4"
794 local DEPENDENCIES="$5"
795 local ARCHS=""
796 local SPATH="aptarchive/dists/${RELEASE}/main/source"
797 mkdir -p $SPATH
798 local FILE="${SPATH}/Sources"
9d2a8a73
DK
799 local DSCFILE="${NAME}_${VERSION}.dsc"
800 local TARFILE="${NAME}_${VERSION}.tar.gz"
234675b7
DK
801 echo "Package: $NAME
802Binary: $NAME
803Version: $VERSION
804Maintainer: Joe Sixpack <joe@example.org>
805Architecture: $ARCH" >> $FILE
806 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
807 echo "Files:
9d2a8a73
DK
808 $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
809 $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
d5dea0be 810" >> $FILE
234675b7
DK
811}
812
dfc2b1be
DK
813insertinstalledpackage() {
814 local NAME="$1"
815 local ARCH="$2"
816 local VERSION="$3"
817 local DEPENDENCIES="$4"
d67004e0 818 local PRIORITY="${5:-optional}"
d4b4e5ea 819 local STATUS="${6:-install ok installed}"
14109555 820 local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed
18908589
DK
821 If you find such a package installed on your system,
822 something went horribly wrong! They are autogenerated
823 und used only by testcases and surf no other propose…"}"
824
53ea1b56
DK
825 local FILE='rootdir/var/lib/dpkg/status'
826 local INFO='rootdir/var/lib/dpkg/info'
3dcdc1f9 827 for arch in $(getarchitecturesfromcommalist "$ARCH"); do
d67004e0 828 echo "Package: $NAME
d4b4e5ea 829Status: $STATUS
d67004e0 830Priority: $PRIORITY
dfc2b1be
DK
831Section: other
832Installed-Size: 42
833Maintainer: Joe Sixpack <joe@example.org>
dfc2b1be 834Version: $VERSION" >> $FILE
c919ad6e 835 test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE
d67004e0 836 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
18908589
DK
837 echo "Description: $DESCRIPTION" >> $FILE
838 echo >> $FILE
53ea1b56
DK
839 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
840 echo -n > ${INFO}/${NAME}:${arch}.list
841 else
842 echo -n > ${INFO}/${NAME}.list
843 fi
d67004e0 844 done
dfc2b1be
DK
845}
846
847
ce9864a8 848buildaptarchivefromincoming() {
3cbbda3c 849 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
850 cd aptarchive
851 [ -e pool ] || ln -s ../incoming pool
852 [ -e ftparchive.conf ] || createaptftparchiveconfig
853 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 854 msgninfo "\tGenerate Packages, Sources and Contents files… "
31be38d2 855 testsuccess aptftparchive generate ftparchive.conf
ce9864a8
DK
856 cd - > /dev/null
857 msgdone "info"
4dbfe436 858 generatereleasefiles "$@"
ce9864a8
DK
859}
860
861buildaptarchivefromfiles() {
3cbbda3c 862 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
8d041b4f
DK
863 local DIR='aptarchive'
864 if [ -d "${DIR}/dists" ]; then DIR="${DIR}/dists"; fi
865 find "$DIR" -name 'Packages' -o -name 'Sources' -o -name 'Translation-*' | while read line; do
9b78cda6 866 msgninfo "\t${line} file… "
276e51dd 867 compressfile "$line" "$1"
8d876415 868 msgdone "info"
9b78cda6 869 done
e3c62328 870 generatereleasefiles "$@"
9b78cda6
DK
871}
872
276e51dd
DK
873compressfile() {
874 cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do
875 if [ "$compressor" = '.' ]; then
876 if [ -n "$2" ]; then
877 touch -d "$2" "$1"
878 fi
879 continue
880 fi
881 cat "$1" | $command > "${1}.${extension}"
882 if [ -n "$2" ]; then
883 touch -d "$2" "${1}.${extension}"
884 fi
885 done
886}
887
a3bbbab7 888# can be overridden by testcases for their pleasure
bf9e7447
DK
889getcodenamefromsuite() {
890 case "$1" in
891 unstable) echo 'sid';;
892 *) echo -n "$1";;
893 esac
894}
a3bbbab7 895getreleaseversionfromsuite() { true; }
718f797c 896getlabelfromsuite() { true; }
d56e2917 897getoriginfromsuite() { true; }
a3bbbab7 898
9b78cda6 899generatereleasefiles() {
884a4c0a
DK
900 # $1 is the Date header and $2 is the ValidUntil header to be set
901 # both should be given in notation date/touch can understand
9b78cda6
DK
902 msgninfo "\tGenerate Release files… "
903 if [ -e aptarchive/dists ]; then
904 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
905 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
906 local CODENAME="$(getcodenamefromsuite $SUITE)"
907 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 908 local LABEL="$(getlabelfromsuite $SUITE)"
d56e2917 909 local ORIGIN="$(getoriginfromsuite $SUITE)"
884a4c0a 910 if [ -n "$VERSION" ]; then
718f797c
DK
911 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
912 fi
913 if [ -n "$LABEL" ]; then
914 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 915 fi
d56e2917
DK
916 if [ -n "$ORIGIN" ]; then
917 ORIGIN="-o APT::FTPArchive::Release::Origin=${ORIGIN}"
918 fi
884a4c0a
DK
919 aptftparchive -qq release $dir \
920 -o APT::FTPArchive::Release::Suite="${SUITE}" \
921 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 922 ${LABEL} \
d56e2917 923 ${ORIGIN} \
884a4c0a
DK
924 ${VERSION} \
925 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 926 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
927 sed -i '/^Date: / a\
928NotAutomatic: yes' $dir/Release
929 fi
884a4c0a
DK
930 if [ -n "$1" -a "$1" != "now" ]; then
931 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
932 fi
933 if [ -n "$2" ]; then
934 sed -i "/^Date: / a\
935Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
936 fi
9b78cda6
DK
937 done
938 else
939 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 940 fi
884a4c0a 941 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
942 for release in $(find ./aptarchive -name 'Release'); do
943 touch -d "$1" $release
944 done
8d876415 945 fi
b7899b00 946 msgdone "info"
8d876415
DK
947}
948
b7899b00
DK
949setupdistsaptarchive() {
950 local APTARCHIVE=$(readlink -f ./aptarchive)
951 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
952 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
953 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
954 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
955 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
956 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
957 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
958 msgdone "info"
959 done
960}
961
962setupflataptarchive() {
ce9864a8 963 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
964 if [ -f ${APTARCHIVE}/Packages ]; then
965 msgninfo "\tadd deb sources.list line… "
966 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
967 msgdone "info"
968 else
969 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
970 fi
971 if [ -f ${APTARCHIVE}/Sources ]; then
972 msgninfo "\tadd deb-src sources.list line… "
973 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
974 msgdone "info"
975 else
976 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
977 fi
b7899b00
DK
978}
979
980setupaptarchive() {
4dbfe436
DK
981 local NOUPDATE=0
982 if [ "$1" = '--no-update' ]; then
983 NOUPDATE=1
984 shift
985 fi
986 buildaptarchive "$@"
b7899b00
DK
987 if [ -e aptarchive/dists ]; then
988 setupdistsaptarchive
989 else
990 setupflataptarchive
991 fi
9d653a6d 992 signreleasefiles 'Joe Sixpack'
4dbfe436 993 if [ "1" != "$NOUPDATE" ]; then
5684f71f 994 testsuccess aptget update -o Debug::pkgAcquire::Worker=true -o Debug::Acquire::gpgv=true
b2ea1a47 995 fi
8d876415
DK
996}
997
f213b6ea
DK
998signreleasefiles() {
999 local SIGNER="${1:-Joe Sixpack}"
07cb47e7 1000 local REPODIR="${2:-aptarchive}"
f1e1abd8 1001 local KEY="keys/$(echo "$SIGNER" | tr 'A-Z' 'a-z' | sed 's# ##g')"
33a22672 1002 local GPG="aptkey --quiet --keyring ${KEY}.pub --secret-keyring ${KEY}.sec --readonly adv --batch --yes"
f1e1abd8 1003 msgninfo "\tSign archive with $SIGNER key $KEY… "
29a59c46
DK
1004 local REXKEY='keys/rexexpired'
1005 local SECEXPIREBAK="${REXKEY}.sec.bak"
1006 local PUBEXPIREBAK="${REXKEY}.pub.bak"
1007 if [ "${SIGNER}" = 'Rex Expired' ]; then
1008 # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time
1009 # option doesn't exist anymore (and using faketime would add a new obscure dependency)
1010 # therefore we 'temporary' make the key not expired and restore a backup after signing
1011 cp ${REXKEY}.sec $SECEXPIREBAK
1012 cp ${REXKEY}.pub $PUBEXPIREBAK
1013 local SECUNEXPIRED="${REXKEY}.sec.unexpired"
1014 local PUBUNEXPIRED="${REXKEY}.pub.unexpired"
1015 if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then
1016 cp $SECUNEXPIRED ${REXKEY}.sec
1017 cp $PUBUNEXPIRED ${REXKEY}.pub
1018 else
f1e1abd8
DK
1019 if ! printf "expire\n1w\nsave\n" | $GPG --default-key "$SIGNER" --command-fd 0 --edit-key "${SIGNER}" >setexpire.gpg 2>&1; then
1020 cat setexpire.gpg
1021 exit 1
1022 fi
29a59c46
DK
1023 cp ${REXKEY}.sec $SECUNEXPIRED
1024 cp ${REXKEY}.pub $PUBUNEXPIRED
1025 fi
1026 fi
07cb47e7 1027 for RELEASE in $(find ${REPODIR}/ -name Release); do
29a59c46 1028 $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE}
e3c62328 1029 local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')"
29a59c46 1030 $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE
e3c62328
DK
1031 # we might have set a specific date for the Release file, so copy it
1032 touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE}
f213b6ea 1033 done
29a59c46
DK
1034 if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then
1035 mv -f $SECEXPIREBAK ${REXKEY}.sec
1036 mv -f $PUBEXPIREBAK ${REXKEY}.pub
1037 fi
f213b6ea
DK
1038 msgdone "info"
1039}
1040
8eafc759
DK
1041redatereleasefiles() {
1042 local DATE="$(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')"
1043 for release in $(find aptarchive/ -name 'Release'); do
1044 sed -i "s/^Date: .*$/Date: ${DATE}/" $release
1045 touch -d "$DATE" $release
1046 done
1047 signreleasefiles "${2:-Joe Sixpack}"
1048}
1049
f2c0ec8b 1050webserverconfig() {
ba6b79bd 1051 local WEBSERVER="${3:-http://localhost:8080}"
b0314abb
DK
1052 local NOCHECK=false
1053 if [ "$1" = '--no-check' ]; then
1054 NOCHECK=true
1055 shift
1056 fi
0d58c26a 1057 local DOWNLOG='rootdir/tmp/download-testfile.log'
b0314abb 1058 local STATUS='downloaded/webserverconfig.status'
0d58c26a 1059 rm -f "$STATUS" "$DOWNLOG"
b0314abb
DK
1060 local URI
1061 if [ -n "$2" ]; then
1062 msgtest "Set webserver config option '${1}' to" "$2"
ba6b79bd 1063 URI="${WEBSERVER}/_config/set/${1}/${2}"
b0314abb
DK
1064 else
1065 msgtest 'Clear webserver config option' "${1}"
ba6b79bd 1066 URI="${WEBSERVER}/_config/clear/${1}"
b0314abb
DK
1067 fi
1068 if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
f2c0ec8b
DK
1069 msgpass
1070 else
b0314abb 1071 cat "$DOWNLOG" "$STATUS" || true
0d58c26a 1072 msgfail
f2c0ec8b 1073 fi
b0314abb 1074 $NOCHECK || testwebserverlaststatuscode '200'
f2c0ec8b
DK
1075}
1076
fd46d305
DK
1077rewritesourceslist() {
1078 local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")"
1079 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
b0314abb 1080 sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#https://localhost:4433/#${1}#"
fd46d305
DK
1081 done
1082}
1083
5572f6bd
MV
1084# wait for up to 10s for a pid file to appear to avoid possible race
1085# when a helper is started and dosn't write the PID quick enough
1086waitforpidfile() {
1087 local PIDFILE="$1"
1088 for i in $(seq 10); do
1089 if test -s "$PIDFILE"; then
1090 return 0
1091 fi
1092 sleep 1
1093 done
1094 msgdie "waiting for $PIDFILE failed"
1095 return 1
1096}
1097
f213b6ea 1098changetowebserver() {
23af9f40
DK
1099 if [ "$1" != '--no-rewrite' ]; then
1100 rewritesourceslist 'http://localhost:8080/'
1101 else
1102 shift
1103 fi
5c0dd6fc 1104 if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then
fbd29dd6 1105 cd aptarchive
a0db467c
DK
1106 local LOG="webserver.log"
1107 if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then
bee0670b
DK
1108 cat $LOG
1109 false
1110 fi
5572f6bd 1111 waitforpidfile aptwebserver.pid
e3c62328
DK
1112 local PID="$(cat aptwebserver.pid)"
1113 if [ -z "$PID" ]; then
1114 msgdie 'Could not fork aptwebserver successfully'
1115 fi
1116 addtrap "kill $PID;"
fbd29dd6 1117 cd - > /dev/null
c5bcc607 1118 else
fbd29dd6 1119 msgdie 'You have to build aptwerbserver or install a webserver'
f213b6ea 1120 fi
fd46d305
DK
1121}
1122
1123changetohttpswebserver() {
1124 if ! which stunnel4 >/dev/null; then
1125 msgdie 'You need to install stunnel4 for https testcases'
1126 fi
1127 if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then
dc95fee1 1128 changetowebserver --no-rewrite "$@"
fd46d305
DK
1129 fi
1130 echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid
68ba0b7f 1131cert = ${TMPWORKINGDIRECTORY}/rootdir/etc/webserver.pem
23af9f40 1132output = /dev/null
fd46d305
DK
1133
1134[https]
1135accept = 4433
1136connect = 8080
1137" > ${TMPWORKINGDIRECTORY}/stunnel.conf
1138 stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf"
5572f6bd 1139 waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid"
fd46d305 1140 local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)"
5572f6bd
MV
1141 if [ -z "$PID" ]; then
1142 msgdie 'Could not fork stunnel4 successfully'
1143 fi
fd46d305
DK
1144 addtrap 'prefix' "kill ${PID};"
1145 rewritesourceslist 'https://localhost:4433/'
f213b6ea
DK
1146}
1147
c45233ea
DK
1148changetocdrom() {
1149 mkdir -p rootdir/media/cdrom/.disk
1150 local CD="$(readlink -f rootdir/media/cdrom)"
a0975c8d
DK
1151 echo "acquire::cdrom::mount \"${CD}\";
1152acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\";
1153acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\";
1154acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom
c45233ea
DK
1155 echo -n "$1" > ${CD}/.disk/info
1156 if [ ! -d aptarchive/dists ]; then
1157 msgdie 'Flat file archive cdroms can not be created currently'
1158 return 1
1159 fi
a0975c8d 1160 mv aptarchive/dists "$CD"
c45233ea
DK
1161 ln -s "$(readlink -f ./incoming)" $CD/pool
1162 find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete
a0975c8d
DK
1163 # start with an unmounted disk
1164 mv "${CD}" "${CD}-unmounted"
1165 # we don't want the disk to be modifiable
1166 addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;"
b0314abb 1167 chmod -R 555 rootdir/media/cdrom-unmounted/dists
c45233ea
DK
1168}
1169
fd46d305 1170downloadfile() {
ed793a19 1171 local PROTO="${1%%:*}"
27925d82 1172 if ! apthelper -o Debug::Acquire::${PROTO}=1 -o Debug::pkgAcquire::Worker=1 \
dcbb364f 1173 download-file "$1" "$2" "$3" 2>&1 ; then
27925d82
DK
1174 return 1
1175 fi
fd46d305 1176 # only if the file exists the download was successful
b0314abb 1177 if [ -r "$2" ]; then
fd46d305
DK
1178 return 0
1179 else
1180 return 1
1181 fi
1182}
1183
f213b6ea 1184checkdiff() {
03aa0847 1185 local DIFFTEXT="$(command diff -u "$@" 2>&1 | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
8d876415 1186 if [ -n "$DIFFTEXT" ]; then
0d58c26a
DK
1187 echo >&2
1188 echo >&2 "$DIFFTEXT"
8d876415
DK
1189 return 1
1190 else
1191 return 0
1192 fi
1193}
1194
75954ae2
DK
1195testfileequal() {
1196 local FILE="$1"
1197 shift
1198 msgtest "Test for correctness of file" "$FILE"
1199 if [ -z "$*" ]; then
6bf93605 1200 echo -n "" | checkdiff - $FILE && msgpass || msgfail
75954ae2 1201 else
6bf93605 1202 echo "$*" | checkdiff - $FILE && msgpass || msgfail
75954ae2
DK
1203 fi
1204}
1205
b855a400
DK
1206testempty() {
1207 msgtest "Test for no output of" "$*"
859093da 1208 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
ab25bf1f 1209 if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
859093da
DK
1210 msgpass
1211 else
061ee5f0 1212 echo
859093da
DK
1213 cat $COMPAREFILE
1214 msgfail
1215 fi
ab25bf1f 1216 aptautotest 'testempty' "$@"
b855a400
DK
1217}
1218
f74a6fa1
DK
1219testequal() {
1220 local MSG='Test of equality of'
1221 if [ "$1" = '--nomsg' ]; then
1222 MSG=''
1223 shift
1224 fi
1225
03938280 1226 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile"
8d876415
DK
1227 echo "$1" > $COMPAREFILE
1228 shift
d2d68aaf 1229
f74a6fa1
DK
1230 if [ -n "$MSG" ]; then
1231 msgtest "$MSG" "$*"
1232 fi
ab25bf1f
DK
1233 "$@" 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1234 aptautotest 'testequal' "$@"
8d876415
DK
1235}
1236
685625bd 1237testequalor2() {
03938280
DK
1238 local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
1239 local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
1240 local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
685625bd
DK
1241 echo "$1" > $COMPAREFILE1
1242 echo "$2" > $COMPAREFILE2
1243 shift 2
1244 msgtest "Test for equality OR of" "$*"
ab25bf1f 1245 "$@" >$COMPAREAGAINST 2>&1 || true
0d58c26a
DK
1246 if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \
1247 checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1
1248 then
0caa5a4c
DK
1249 msgpass
1250 else
1251 echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
1252 checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
1253 echo -n "${CINFO}Diff against OR 2${CNORMAL}"
1254 checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
1255 msgfail
1256 fi
ab25bf1f 1257 aptautotest 'testequalor2' "$@"
685625bd
DK
1258}
1259
8d876415 1260testshowvirtual() {
edc0ef10 1261 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1262 local PACKAGE="$1"
1263 shift
1264 while [ -n "$1" ]; do
1265 VIRTUAL="${VIRTUAL}
edc0ef10 1266N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
1267 PACKAGE="${PACKAGE} $1"
1268 shift
1269 done
1270 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
1271 VIRTUAL="${VIRTUAL}
4bec02c2 1272N: No packages found"
03938280 1273 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
ea65d079 1274 local ARCH="$(getarchitecture 'native')"
8d876415 1275 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 1276 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
1277}
1278
1279testnopackage() {
1280 msgtest "Test for non-existent packages" "apt-cache show $*"
846856f4 1281 local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
8d876415 1282 if [ -n "$SHOWPKG" ]; then
0d58c26a
DK
1283 echo >&2
1284 echo >&2 "$SHOWPKG"
8d876415 1285 msgfail
0d58c26a
DK
1286 else
1287 msgpass
8d876415 1288 fi
8d876415 1289}
01a6e24c 1290
ecb777dd
DK
1291testdpkgstatus() {
1292 local STATE="$1"
1293 local NR="$2"
1294 shift 2
1295 msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
1296 local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
1297 if [ "$PKGS" != $NR ]; then
0d58c26a 1298 echo >&2 $PKGS
c9443c01 1299 dpkg -l "$@" | grep '^[a-z]' >&2 || true
01a6e24c 1300 msgfail
0d58c26a
DK
1301 else
1302 msgpass
01a6e24c 1303 fi
01a6e24c
DK
1304}
1305
ecb777dd
DK
1306testdpkginstalled() {
1307 testdpkgstatus 'ii' "$#" "$@"
1308}
1309
5cf733e1 1310testdpkgnotinstalled() {
ecb777dd 1311 testdpkgstatus 'ii' '0' "$@"
01a6e24c 1312}
ec7f904e
DK
1313
1314testmarkedauto() {
03938280 1315 local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
ec7f904e
DK
1316 if [ -n "$1" ]; then
1317 msgtest 'Test for correctly marked as auto-installed' "$*"
1318 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
1319 else
1320 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 1321 echo -n > $COMPAREFILE
ec7f904e
DK
1322 fi
1323 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
1324}
89a1aa5d 1325
e52aad52
DK
1326msgfailoutput() {
1327 local MSG="$1"
1328 local OUTPUT="$2"
1329 shift 2
1330 echo >&2
1331 if [ "$1" = 'grep' ]; then
1332 while [ -n "$2" ]; do shift; done
1333 echo "#### Complete file: $1 ####"
1334 cat >&2 "$1" || true
1335 echo '#### grep output ####'
1336 elif [ "$1" = 'test' ]; then
1337 # doesn't support ! or non-file flags
1338 msgfailoutputstatfile() {
1339 local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
1340 if expr match "$1" "$FILEFLAGS" >/dev/null; then
1341 echo "#### stat(2) of file: $2 ####"
1342 stat "$2" || true
1343 fi
1344 }
1345 msgfailoutputstatfile "$2" "$3"
1346 while [ -n "$5" ] && [ "$4" = '-o' -o "$4" = '-a' ]; do
1347 shift 3
1348 msgfailoutputstatfile "$2" "$3"
1349 done
1350 echo '#### test output ####'
1351 fi
1352 cat >&2 $OUTPUT
1353 msgfail "$MSG"
1354}
1355
0440d936
DK
1356testsuccess() {
1357 if [ "$1" = '--nomsg' ]; then
1358 shift
1359 else
1360 msgtest 'Test for successful execution of' "$*"
1361 fi
03938280 1362 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output"
4fa34122
DK
1363 if "$@" >${OUTPUT} 2>&1; then
1364 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1365 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1366 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1367 elif grep -q -E '^[WE]: ' "$OUTPUT"; then
1368 msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
4fa34122
DK
1369 else
1370 msgpass
1371 fi
1372 else
1373 msgpass
1374 fi
1375 else
1376 local EXITCODE=$?
e52aad52 1377 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
4fa34122
DK
1378 fi
1379 aptautotest 'testsuccess' "$@"
1380}
1381testwarning() {
1382 if [ "$1" = '--nomsg' ]; then
1383 shift
1384 else
1385 msgtest 'Test for successful execution with warnings of' "$*"
1386 fi
25b86db1 1387 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output"
1df24acf
DK
1388 if "$@" >${OUTPUT} 2>&1; then
1389 if expr match "$1" '^apt.*' >/dev/null; then
e52aad52
DK
1390 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1391 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1392 elif grep -q -E '^E: ' "$OUTPUT"; then
1393 msgfailoutput 'successful run, but output contains errors' "$OUTPUT" "$@"
4fa34122 1394 elif ! grep -q -E '^W: ' "$OUTPUT"; then
e52aad52 1395 msgfailoutput 'successful run, but output contains no warnings' "$OUTPUT" "$@"
1df24acf
DK
1396 else
1397 msgpass
1398 fi
1399 else
1400 msgpass
1401 fi
0440d936 1402 else
07cb47e7 1403 local EXITCODE=$?
0d58c26a
DK
1404 echo >&2
1405 cat >&2 $OUTPUT
07cb47e7 1406 msgfail "exitcode $EXITCODE"
0440d936 1407 fi
4fa34122 1408 aptautotest 'testwarning' "$@"
0440d936 1409}
0440d936
DK
1410testfailure() {
1411 if [ "$1" = '--nomsg' ]; then
1412 shift
1413 else
889b0072 1414 msgtest 'Test for failure in execution of' "$*"
0440d936 1415 fi
03938280 1416 local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1df24acf 1417 if "$@" >${OUTPUT} 2>&1; then
07cb47e7 1418 local EXITCODE=$?
e52aad52 1419 msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
0440d936 1420 else
1df24acf
DK
1421 local EXITCODE=$?
1422 if expr match "$1" '^apt.*' >/dev/null; then
b0d40854
DK
1423 if [ "$1" = 'aptkey' ]; then
1424 if grep -q -E " Can't check signature: " "$OUTPUT" || \
1425 grep -q -E " BAD signature from " "$OUTPUT"; then
1426 msgpass
1427 else
1428 msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
1429 fi
1df24acf 1430 else
b0d40854
DK
1431 if grep -q -E ' runtime error: ' "$OUTPUT"; then
1432 msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
1433 elif grep -q -E '==ERROR' "$OUTPUT"; then
1434 msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
1435 elif ! grep -q -E '^E: ' "$OUTPUT"; then
1436 msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
1437 else
1438 msgpass
1439 fi
1df24acf
DK
1440 fi
1441 else
1442 msgpass
1443 fi
0440d936 1444 fi
ab25bf1f 1445 aptautotest 'testfailure' "$@"
0440d936
DK
1446}
1447
25b86db1
DK
1448testsuccessequal() {
1449 local CMP="$1"
1450 shift
1451 testsuccess "$@"
1452 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$CMP"
1453}
1454testwarningequal() {
1455 local CMP="$1"
1456 shift
1457 testwarning "$@"
1458 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" "$CMP"
1459}
1460testfailureequal() {
1461 local CMP="$1"
1462 shift
1463 testfailure "$@"
1464 testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" "$CMP"
1465}
1466
27925d82
DK
1467testfailuremsg() {
1468 local CMP="$1"
1469 shift
1470 testfailure "$@"
1471 msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
1472 grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output" 2>&1 || true
1473 if echo "$CMP" | checkdiff - "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output"; then
1474 msgpass
1475 else
1476 echo '### Complete output ###'
1477 cat "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
1478 msgfail
1479 fi
1480}
25b86db1 1481
de81b2e2
DK
1482testfilestats() {
1483 msgtest "Test that file $1 has $2 $3" "$4"
1484 if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
5684f71f
DK
1485 msgpass
1486 else
1487 echo >&2
d56e2917 1488 ls -ld >&2 "$1" || true
de81b2e2 1489 echo -n >&2 "stat(1) reports for $2: "
d56e2917 1490 stat --format "$2" "$1" || true
5684f71f
DK
1491 msgfail
1492 fi
1493}
de81b2e2
DK
1494testaccessrights() {
1495 testfilestats "$1" '%a' '=' "$2"
1496}
5684f71f 1497
0d58c26a
DK
1498testwebserverlaststatuscode() {
1499 local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
03aa0847 1500 local STATUS='downloaded/webserverstatus-statusfile.log'
0d58c26a
DK
1501 rm -f "$DOWNLOG" "$STATUS"
1502 msgtest 'Test last status code from the webserver was' "$1"
b0314abb 1503 if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
0d58c26a
DK
1504 msgpass
1505 else
1506 echo >&2
1507 if [ -n "$2" ]; then
1508 shift
1509 echo >&2 '#### Additionally provided output files contain:'
1510 cat >&2 "$@"
1511 fi
1512 echo >&2 '#### Download log of the status code:'
1513 cat >&2 "$DOWNLOG"
1514 msgfail "Status was $(cat "$STATUS")"
1515 fi
1516}
1517
89a1aa5d
DK
1518pause() {
1519 echo "STOPPED execution. Press enter to continue"
1520 local IGNORE
1521 read IGNORE
1522}
ab25bf1f 1523
846bc058 1524listcurrentlistsdirectory() {
ba6b79bd
DK
1525 {
1526 find rootdir/var/lib/apt/lists -maxdepth 1 -type d | while read line; do
1527 stat --format '%U:%G:%a:%n' "$line"
1528 done
1529 find rootdir/var/lib/apt/lists -maxdepth 1 \! -type d | while read line; do
1530 stat --format '%U:%G:%a:%s:%y:%n' "$line"
1531 done
1532 } | sort
846bc058
DK
1533}
1534
8fe964f1
DK
1535### convinience hacks ###
1536mkdir() {
1537 # creating some directories by hand is a tedious task, so make it look simple
1538 if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||
1539 [ "$*" = '-p rootdir/var/lib/apt/lists/partial' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" ]; then
1540 # only the last directory created by mkdir is effected by the -m !
1541 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt"
1542 command mkdir -m 755 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"
1543 command mkdir -m 700 -p "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1544 touch "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/lock"
1545 if [ "$(id -u)" = '0' ]; then
1546 chown _apt:root "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial"
1547 fi
1548 else
1549 command mkdir "$@"
1550 fi
1551}
1552
ab25bf1f
DK
1553### The following tests are run by most test methods automatically to check
1554### general things about commands executed without writing the test every time.
1555
1556aptautotest() {
1557 local TESTCALL="$1"
1558 local CMD="$2"
1559 local FIRSTOPT="$3"
1560 local AUTOTEST="aptautotest_$(basename "$CMD" | tr -d '-')_$(echo "$FIRSTOPT" | tr -d '-')"
1561 if command -v $AUTOTEST >/dev/null; then
1562 shift 3
1563 # save and restore the *.output files from other tests
1564 # as we might otherwise override them in these automatic tests
03aa0847
DK
1565 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1566 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-before
1567 mkdir ${TMPWORKINGDIRECTORY}/rootdir/tmp
ab25bf1f 1568 $AUTOTEST "$TESTCALL" "$@"
03aa0847
DK
1569 rm -rf ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1570 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp ${TMPWORKINGDIRECTORY}/rootdir/tmp-aptautotest
1571 mv ${TMPWORKINGDIRECTORY}/rootdir/tmp-before ${TMPWORKINGDIRECTORY}/rootdir/tmp
ab25bf1f
DK
1572 fi
1573}
1574
1575aptautotest_aptget_update() {
59148d96
DK
1576 local TESTCALL="$1"
1577 while [ -n "$2" ]; do
1578 if [ "$2" = '--print-uris' ]; then return; fi # simulation mode
1579 shift
1580 done
ab25bf1f 1581 if ! test -d "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists"; then return; fi
4bb006d1
DK
1582 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
1583 testfilestats "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:755"
ab25bf1f 1584 # all copied files are properly chmodded
146f7715 1585 for file in $(find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" -type f ! -name 'lock'); do
4bb006d1 1586 testfilestats "$file" '%U:%G:%a' '=' "${TEST_DEFAULT_USER}:${TEST_DEFAULT_GROUP}:644"
ab25bf1f 1587 done
59148d96 1588 if [ "$TESTCALL" = 'testsuccess' ]; then
146f7715
DK
1589 # failure cases can retain partial files and such
1590 testempty find "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists/partial" -mindepth 1 ! \( -name 'lock' -o -name '*.FAILED' \)
1591 fi
ab25bf1f
DK
1592}
1593aptautotest_apt_update() { aptautotest_aptget_update "$@"; }
d84da499 1594aptautotest_aptcdrom_add() { aptautotest_aptget_update "$@"; }
016bea82
DK
1595
1596testaptautotestnodpkgwarning() {
1597 local TESTCALL="$1"
1598 while [ -n "$2" ]; do
6bf93605
DK
1599 if expr match "$2" '^-[a-z]*s' >/dev/null 2>&1; then return; fi # simulation mode
1600 if expr match "$2" '^-dy\?' >/dev/null 2>&1; then return; fi # download-only mode
016bea82
DK
1601 shift
1602 done
1603 testfailure grep '^dpkg: warning:.*ignor.*' "${TMPWORKINGDIRECTORY}/rootdir/tmp-before/${TESTCALL}.output"
1604}
1605
1606aptautotest_aptget_install() { testaptautotestnodpkgwarning "$@"; }
1607aptautotest_aptget_remove() { testaptautotestnodpkgwarning "$@"; }
1608aptautotest_aptget_purge() { testaptautotestnodpkgwarning "$@"; }
1609aptautotest_apt_install() { testaptautotestnodpkgwarning "$@"; }
1610aptautotest_apt_remove() { testaptautotestnodpkgwarning "$@"; }
1611aptautotest_apt_purge() { testaptautotestnodpkgwarning "$@"; }